{$I DEFINES.INC}
unit Restore;

interface

uses
  Views{$IFDEF WIN32}, Windows{$ENDIF};

const
  MaxScreenHeight = 60;

type
  PTheScreen = ^TTheScreen;
  TTheScreen = array[1..MaxScreenHeight] of TDrawBuffer;
  {$IFDEF WIN32}TScreenBuf = Array[1..25, 1..80] of TCharInfo;{$ENDIF} { REETODO Shouldn't be hardcoded to 80x25 }

var
  PScreen: PTheScreen;

implementation

uses
  Crt, Drivers;

const
  ScreenMode = $49;
  ScreenCols = $4A;
  CursorPos  = $50;
  ScreenRows = $84;

{$ifdef VER60}
var
  Seg0040, SegB000, SegB800: Word;
{$endif}

var
  Loop: Byte;
  P: Pointer;
  CursorCoords, Segment, RowSize, Index: Word;
  ExitSave: Pointer;

{$IFDEF WIN32}
var
  BufSize    : TCoord;
  ReadPos    : TCoord;
  SourceRect : TSmallRect;
  StdOut: THandle;
  Screen: TScreenBuf;
  X, Y: Word;
{$ENDIF}
  
{ Exit code performed on program exit }
procedure MyExitProc; far;
{$IFDEF WIN32}
VAR
  BufSize    : TCoord;
  WritePos   : TCoord;
  DestRect   : TSmallRect;
{$ENDIF}
begin
{$IFDEF MSDOS}  
  Index := 0;
  { Iterate over all rows, copying from memory to screen }
  for Loop := 1 to Mem[Seg0040:ScreenRows] do
  begin
    P := Ptr(Segment, Index);
    Move(PScreen^[Loop], P^, RowSize);
    Inc(Index, RowSize)
  end;
  { Free buffer }
  Dispose(PScreen);
  { Restore cursor coordinates }
  MemW[Seg0040:CursorPos] := CursorCoords;
{$ENDIF}
{$IFDEF WIN32}
  BufSize.X       := 80;
  BufSize.Y       := 25;
  WritePos.X      := 0;
  WritePos.Y      := 0;
  DestRect.Left   := 0;
  DestRect.Top    := 0;
  DestRect.Right  := 79;
  DestRect.Bottom := 24;
  WriteConsoleOutput(StdOut,@Screen[1][1],BufSize,WritePos,DestRect); { REETODO Shouldn't be hardcoded to 80x25 }
  GotoXY(X, Y);
{$ENDIF}
  ExitProc := ExitSave
end; { MyExitProc }

{ Initialization code performed on program startup }
begin
{$ifdef VER60}
  Seg0040 := $40;
  SegB000 := $B000;
  SegB800 := $B800;
{$endif}
{$IFDEF MSDOS}
  { Save cursor position }
  CursorCoords := MemW[Seg0040:CursorPos];
  { Allocate memory to save screen }
  New(PScreen);
  { Zero the memory }
  FillChar(PScreen^, SizeOf(TTheScreen), 0);
  { Identify what screen type we have }
  if Mem[Seg0040:ScreenMode] = smMono then
    Segment := SegB000
  else
    Segment := SegB800;
  Index := 0;
  { How wide is each row? }
  RowSize := Mem[Seg0040:ScreenCols] shl 1;
  { Iterate over all rows, copying from screen to memory }
  for Loop := 1 to Mem[Seg0040:ScreenRows] do
  begin
    P := Ptr(Segment, Index);
    Move(P^, PScreen^[Loop], RowSize);
    Inc(Index, RowSize)
  end;
{$ENDIF}
{$IFDEF WIN32}
  StdOut := GetStdHandle(STD_OUTPUT_HANDLE);
  BufSize.X         := 80;
  BufSize.Y         := 25;
  ReadPos.X         := 0;
  ReadPos.Y         := 0;
  SourceRect.Left   := 0;
  SourceRect.Top    := 0;
  SourceRect.Right  := 79;
  SourceRect.Bottom := 24;
  ReadConsoleOutput(StdOut,@Screen[1][1],BufSize,ReadPos,SourceRect); { REETODO Shouldn't be hardcoded to 80x25 }
  X := WhereX;
  Y := WhereY;
{$ENDIF}

  ExitSave := ExitProc;
  ExitProc := @MyExitProc
end. { Restore }