{$I DEFINES.INC}
{

Copyright 2007 Jakob Dangarden

 This file is part of Usurper.

    Usurper is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Usurper is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Usurper; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
}


Unit Dungeonc; {Usurper - the dungeons.. main routine}

Interface

Procedure Dungeons(teamdngs:boolean);

Implementation

Uses Init, Cms, Jakob, Dmaze,
     IceCaves, Dungevc, Statusc,
     Supremec, Invent, Plvsmon,
     Mail, News, Various,
     Uman, Npc_Chec, Various2,
     Various3, Online, File_Io;

var
    pl : array [1..4] of ^Userrec; {team-mates are stored here}
    custtemp : ^Userrec; {temporary user record}

Procedure Disposal; {remove pointer variables}
var i : byte;
begin

 for i:=1 to 4 do begin
  dispose(pl[i]);
 end;

 dispose(custtemp);
 {remove shadow players, created by player [teammates]}
 add_shadow(SRemoveShadows,player,'','going to sleep...',0);

end; {disposal *end*}

Procedure Team_Member_Instruct(var plyr:userrec);
var done : boolean;
    ch : char;
begin
 done:=false;
 repeat

  {menu}
  crlf;
  d(config.textcolor,'What should be done with '+uplc+plyr.name2+config.textcol1+'?');
  menu('(E)xamine');
  menu('(K)ick out from group');
  menu('(R)eturn');
  crlf;
  sd(config.textcolor,'Decision :');

  {get user-input}
  ch:=upcase(getchar);

  {evaluate user-input}
  case ch of
   'R': done:=true;
   'E': status(plyr);
   'K':begin {kick out from group}

        d(global_plycol,plyr.name2+config.textcol1+' returns home.');

        {put team member offline / send him home to the town}
        add_shadow(SRemove,plyr,'','',0);

        {save user}
        user_save(plyr);

        {inform plyr of incident}
        post(MailSend,
        plyr.name2,
        plyr.ai,
        false,
        mailrequest_nothing,
        '',
        ulred+'Kicked out!'+config.textcol1,
        mkstring(11,underscore),
        'You were kicked out from the group exploring the Dungeons.',
        'You were sent home by your team-leader: '+uplc+player.name2+config.textcol1+'.',
        '',
        '',
        '',
        '',
        '',
        '',
        '',
        '',
        '',
        '',
        '');

        {empty team member record}
        plyr.name1:='';
        plyr.name2:='';

        {exit procedure}
        done:=true;

        crlf;

       end;

  end; {case .end.}

 until done;

end; {team_member_instruct *end*}

Function Team_Select : integer; {let player select team-mates to follow}
const col = 13; {phrase color}
var
    i : longint;

    y, j  : integer;

    gtext1, gtext2 : s70;

    redisp : boolean;

    ch : char;

    coming : array [1..4] of boolean;
    nice2  : array [1..4] of s90;

    pl0, pl01 : ^UserRec;

begin

 {init pointer vars}
 new(pl0);
 new(pl01);

 coming[1]:=false;
 coming[2]:=false;
 coming[3]:=false;
 coming[4]:=false;

 pl[1]^.name2:='';
 pl[2]^.name2:='';
 pl[3]^.name2:='';
 pl[4]^.name2:='';

 team_select:=0;
 ch:='?';
 y:=0;

 crlf;

 d(config.textcolor,'You hurry off to inform your friends of the coming adventure...');

 for i:=1 to fs(FsPlayer) do begin

  if load_character(pl0^,1,i)=true then begin

   if (pl0^.name2<>'') and
      (pl0^.name2<>player.name2) and
      (pl0^.team=player.team) and
      (is_online(pl0^.name2,online_player)=false) and
      (pl0^.location<>offloc_prison) and
      (pl0^.hps>0) then begin

    if add_shadow(SAdd,pl0^,player.name2,'teaming up with '+uplc+player.name2+config.textcol1,0) then begin

     inc(y);
     coming[y]:=true;
     pl[y]^:=pl0^;
    end;
   end;
   if pl[4]^.name2<>'' then begin
    break;
   end;
  end;

 end; {for i:= .end.}

 for i:=1 to fs(FsNpc) do begin

  if load_character(pl0^,2,i)=true then begin

   if (pl0^.name2<>'') and
      (pl0^.name2<>player.name2) and
      (pl0^.team=player.team) and
      (is_online(pl0^.name2,online_player)=false) and
      (pl0^.location<>offloc_prison) and
      (pl0^.hps>0) then begin

    if add_shadow(SAdd,pl0^,player.name2,'teaming up with '+uplc+player.name2+config.textcol1,0) then begin

     inc(y);
     coming[y]:=true;
     pl[y]^:=pl0^;
    end;

   end;
   if pl[4]^.name2<>'' then begin
    break;
   end;
  end;

 end; {for i:= .end.}

 if y=0 then begin
  crlf;
  d(12,'No teammembers found! (they might be dead or on-line)');
  crlf;
  pause;
  dispose(pl0);
  dispose(pl01);
  exit;
 end;

 crlf;
 if y>1 then begin
  d(5,'You are faced with the hard facts of life.');
  d(5,'Shall you really bring the whole team?');
  d(5,'The weak may get killed very easily!');
 end
 else begin
  sd(5,'You and ');
  sd(global_plycol,pl[1]^.name2);
  d(5,' sit down to discuss the situations that');
  d(5,'may arise on your journey...');
 end;
 redisp:=true;

 gtext1:=' ready';
 gtext2:=' sulking in a corner, not allowed to join';
 repeat
  if redisp=true then begin
   crlf;
   for i:=1 to y do begin
    case i of
     1:begin
        menu2('(1) ');
        sd(global_plycol,pl[1]^.name2);
        if coming[1]=true then d(3,gtext1)
                          else d(12,gtext2);
       end;
     2:begin
        menu2('(2) ');
        sd(global_plycol,pl[2]^.name2);
        if coming[2]=true then d(3,gtext1)
                          else d(12,gtext2);
       end;
     3:begin
        menu2('(3) ');
        sd(global_plycol,pl[3]^.name2);
        if coming[3]=true then d(3,gtext1)
                          else d(12,gtext2);
       end;
     4:begin
        menu2('(4) ');
        sd(global_plycol,pl[4]^.name2);
        if coming[4]=true then d(3,gtext1)
                          else d(12,gtext2);
       end;

    end; {case .end.}

   end; {for i:= .end.}

   crlf;
   sd(config.textcolor,'[');
   sd(5,Config.ReturnEnter);
   d(config.textcolor,'] to Continue');

   sd(config.textcolor,':');
   redisp:=false;
  end;

  {get user input}
  ch:=upcase(getchar);

  {evaluate user-input}
  case ch of
   '1':begin
        if y>0 then begin
         if coming[1]=true then coming[1]:=false
                           else coming[1]:=true;
         redisp:=true;
        end;
       end;
    '2':begin
         if y>1 then begin
          if coming[2]=true then coming[2]:=false
                            else coming[2]:=true;
          redisp:=true;
         end;
        end;
    '3':begin
         if y>2 then begin
          if coming[3]=true then coming[3]:=false
                            else coming[3]:=true;
          redisp:=true;
         end;
        end;
    '4':begin
         if y>3 then begin
          if coming[4]=true then coming[4]:=false
                            else coming[4]:=true;
          redisp:=true;
         end;
        end;

    char(13):begin
         if (coming[1]=false) and (coming[2]=false) and
            (coming[3]=false) and (coming[4]=false) then begin
          crlf;
          d(12,'You must at least have ONE teammeber with you!');
          pause;
          redisp:=true;
          ch:=' ';
         end;
        end;

  end; {case .end.}

 until ch=ReturnKey;
 team_select:=1;

 crlf;
 {what should the party-members say before the adventure begins}
 for i:=1 to 4 do begin
  if coming[i]=true then begin
   check_inventory(pl[i]^,0,weapon,true,0);

   pl01^:=pl[i]^;
   if pl01^.healing<config.maxheals then begin
    if pl01^.gold+pl01^.bankgold>100 then begin

     {team mate buys healing potions}
     sd(global_talkcol,'I need healing potions! I''ll go and buy some!');
     sd(config.textcolor,', ');
     sd(global_plycol,pl01^.name2);
     d(config.textcolor,' says.');

     auto_healing(pl01^);

     pl[i]^:=pl01^;
     user_save(pl[i]^);

     d(global_plycol,pl01^.name2+config.textcol1+' has returned. (bought some potions)');
     crlf;
    end
    else begin
     sd(global_plycol,'I need healing potions, But I have no '+config.moneytype+'!');
     sd(config.textcolor,', ');
     sd(global_plycol,pl01^.name2);
     d(config.textcolor,' says.');
     crlf;
    end;
   end;
   if pl01^.class in [Cleric,Magician,Sage] then begin
    if (pl01^.mana<pl01^.maxmana) and (random(2)=0) then begin
     sd(global_talkcol,'I don''t have full mana!');
     sd(config.textcolor,', ');
     sd(global_plycol,pl01^.name2);
     d(config.textcolor,' complains.');
    end;
   end;

   case random(12) of
    0:begin
       sd(global_talkcol,'I''m scared....!');
       sd(config.textcolor,', ');
       sd(global_plycol,pl01^.name2);
       d(config.textcolor,' cries.');
      end;
    1:begin
       sd(global_talkcol,'Let''s Go!');
       sd(config.textcolor,', ');
       sd(global_plycol,pl01^.name2);
       d(config.textcolor,' screams.');
      end;
    2:begin
       sd(global_talkcol,'I''m ready');
       sd(config.textcolor,', ');
       sd(global_plycol,pl01^.name2);
       d(config.textcolor,' mutters.');
      end;
    3:begin
       sd(global_talkcol,'What are we waiting for!?');
       sd(config.textcolor,', ');
       sd(global_plycol,pl01^.name2);
       d(config.textcolor,' mutters.');
      end;
    4:begin
       sd(global_talkcol,'Don''t have us killed '+player.name2+'!');
       sd(config.textcolor,', ');
       sd(global_plycol,pl01^.name2);
       d(config.textcolor,' mutters.');
      end;
    5:begin
       sd(global_talkcol,'Let''s have some fun!');
       sd(config.textcolor,', ');
       sd(global_plycol,pl01^.name2);
       d(config.textcolor,' screams.');
      end;
    6:begin
       sd(global_talkcol,'Can we fight a gang after this trip?');
       sd(config.textcolor,', ');
       sd(global_plycol,pl01^.name2);
       d(config.textcolor,' asks.');
      end;
    7:begin
       sd(global_talkcol,'Hehehe....');
       sd(config.textcolor,', ');
       sd(global_plycol,pl01^.name2);
       d(config.textcolor,' says and kisses '+sex3[pl01^.sex]+' weapon.');
      end;
    8:begin
       sd(global_talkcol,'LET''S KICK SOME BUTT!');
       sd(config.textcolor,', ');
       sd(global_plycol,pl01^.name2);
       d(config.textcolor,' screams.');
      end;
    9:begin
       sd(global_talkcol,'Lead us to Death or Glory!"');
       sd(config.textcolor,', ');
       sd(global_plycol,pl01^.name2);
       d(config.textcolor,' screams.');
      end;
   10:begin
       sd(global_talkcol,'LET''S KICK SOME BUTT!');
       sd(config.textcolor,', ');
       sd(global_plycol,pl01^.name2);
       d(config.textcolor,' screams.');
      end;
   11:begin
       sd(global_talkcol,'LET''S BREAK SOME BONES!');
       sd(config.textcolor,', ');
       sd(global_plycol,pl01^.name2);
       d(config.textcolor,' screams.');
      end;

   end; {case .end.}
  end;
 end; {for i:= .end.}
 crlf;
 pause;
 crlf;

 {sending a mess to all team-mates that they joined player to the dngs.}

 nice2[1]:=uplc+player.name2+config.textcol1+' took you to the Dungeons.';

 if (pl[1]^.name2<>'') and (pl[1]^.ai='H') then team_report(pl[1]^.name2,1,nice2[1],nice2[2],nice2[3],nice2[4]);
 if (pl[2]^.name2<>'') and (pl[2]^.ai='H') then team_report(pl[2]^.name2,1,nice2[1],nice2[2],nice2[3],nice2[4]);
 if (pl[3]^.name2<>'') and (pl[3]^.ai='H') then team_report(pl[3]^.name2,1,nice2[1],nice2[2],nice2[3],nice2[4]);
 if (pl[4]^.name2<>'') and (pl[4]^.ai='H') then team_report(pl[4]^.name2,1,nice2[1],nice2[2],nice2[3],nice2[4]);

 for i:=1 to 4 do begin
  if pl[i]^.name2<>'' then begin
   if coming[i]=false then begin
    add_shadow(SRemove,pl[i]^,'','',0);
    pl[i]^.name2:='';
   end
   else begin
    update_shadow(pl[i]^.name2,'teamed up with '+uplc+player.name2+config.textcol1,false);
   end;
  end;
 end; {for i:= .end.}

 dispose(pl0);
 dispose(pl01);

end; {Team_Select *end*}

Procedure Dungeons; {MAIN PROC **START**}
var
    z, zz, yy, xx, i, x, j : longint;

    dungeon_difficulty,
    y, need : integer;

    leave_dungeons,
    done, alive, demon,
    first : boolean;

    ch,
    cho : char;

    s,s2 : s100;
    header,
    dungeon_name : s70;

    nice2 : array [1..4] of s90;

begin

 {init pointer variables}
 for i:=1 to 4 do begin
  new(pl[i]);
 end;
 new(custtemp);

 s2:='solen skiner'; {only people who speak swedish will understand this}

 pl[1]^.name2:='';
 pl[2]^.name2:='';
 pl[3]^.name2:='';
 pl[4]^.name2:='';

 if (teamdngs=true) and
    (player.team<>'') and
    (global_auto_probe=Nowhere) then begin
  crlf;
  crlf;
  sd(config.textcolor,'Bring Your Team (');
  sd(global_teamcol,player.team);
  if confirm(')','N')=true then begin
   cho:='Y';
  end
  else begin
   cho:='N';
  end;

  {evaluate user input}
  case cho of
   'Y':begin
        d(11,'Yes, bring the team!');
        if Team_Select<>0 then begin
         case random(4) of
          0: s:='brave';
          1: s:='famous';
          2: s:='deadly';
          3: s:='legendary';
         end;

         {news-paper}
         newsy(true,
         'Party Leaves for Fame & Glory!',
         ' '+uplc+player.name2+config.textcol1+' took '+sex3[player.sex]+' '+s+' team to the dungeons.',
         '',
         '',
         '',
         '',
         '',
         '',
         '',
         '');

        end;
       end;
  end; {case .end.}
 end;

 clearscreen;

 crlf;
 d(config.textcolor,'The Monsters are gathering...');

 {fetching dungeon name from .CFG}
 dungeon_name:=cfg_string(43);
 if dungeon_name='' then begin
  dungeon_name:='Mindor';
 end;

 {Set Dungeon Level}
 global_dungeonlevel:=player.level;
 first:=false;

 crlf;
 d(5,'The Dungeons of '+dungeon_name);
 d(config.textcolor,'As you descend to Dungeon Level '+uwhite+commastr(player.level)+config.textcol1
  +' you tighten your grip to your weapon.');
 d(config.textcolor,'You feel that evil lurk nearby... You wonder whether you ever shall');
 d(config.textcolor,'see the sun shine again...');

 if (pl[1]^.name2<>'') or (pl[2]^.name2<>'') or
    (pl[3]^.name2<>'') or (pl[4]^.name2<>'') then begin
  crlf;
  d(15,'[YOUR TEAM IS WITH YOU]');
 end;

 {dungeon difficulty}
 s:=cfg_string(10);
 dungeon_difficulty:=str_to_nr(s);
 if (dungeon_difficulty<1) or (dungeon_difficulty>10) then begin
  dungeon_difficulty:=2;
 end;

 {*** Main loop ***}
 leave_dungeons:=false;
 repeat
  demon:=false;
  crlf;

  {list of online players}
  if player.ear=1 then begin
   who_is_here;
  end;

  {dungeon fights left}
  sd(config.textcolor,'[');
  sd(11,commastr(player.fights));
  d(config.textcolor,' fights left]');

  {update online location, if necessary}
  if onliner.location<>onloc_dungeons then begin
   onliner.location:=onloc_dungeons;
   add_onliner(OUpdateLocation,Onliner);
  end;

  {level raise}
  x:=level_raise(player.level,player.exp);
  if x=0 then begin
   d(15,global_levelraise);
  end;

  {menu}
  sd(config.textcolor,'Dungeon level '+umag+commastr(global_dungeonlevel)+config.textcol1+' (');
  sd(config.textcolor,config.textcol2+'?'+config.textcol1+' for menu) :');

  s:='';
  case global_auto_probe of
   NoWhere:begin
            ch:=upcase(getchar);
           end;
   UmanCave:begin
             uman_cave;
             ch:='?';
            end;
  end; {case .end.}

  {evaluate user-input}
  case ch of

   ReturnKey : crlf;

   'S':begin {status}
        clearscreen;
        status(player);
        crlf;
       end;
   '?':begin {display menu}

        s:='The Dungeons of '+dungeon_name;
        clearscreen;
        crlf;
        d(5,s);
        crlf;
        menu('(L)ook for creatures');
        menu('(H)ealing');
        menu('(Q)uick heal');
        if global_icemap then begin
         {menu('(I)ce Caves'); jakob}
        end;

        if global_ubeta then begin

         {menu('(D)eath maze');}

        end;
        menu('(U)man caves');


        if (player_active(pl[1]^,true)=true) or
           (player_active(pl[2]^,true)=true) or
           (player_active(pl[3]^,true)=true) or
           (player_active(pl[4]^,true)=true) then begin
         menu('(T)eam orders');
        end;

        menu('(C)hange dungeon level');
        menu('(S)tatus');
        menu('(R)eturn to town');

       end;
     'R':begin {return to town}
        leave_dungeons:=true;
       end;
   'U':begin {uman caves}
        crlf;
        crlf;
        d(10,'You have entered a new area.');
        uman_cave;
       end;
   'D':begin {death maze, nothing serious. a test area for the programmer}

        if global_utest=false then begin
         crlf;
         crlf;
         death_maze;
        end
        else begin
         crlf;
         crlf;
         d(12,'The Maze is not for you to explore!');
        end;

       end;
   'H':begin {healing}
        healing(player);
       end;
   'Q':begin {quick healing}
        quick_healing(player);
       end;
   'I':begin {ice-caves}

        crlf;
        crlf;
        d(15,'Sorry, this area wasn''t ready to the release of this version.');
        d(15,'The author had other priorities.');
        crlf;
        pause;
        {if global_icemap then begin
         clearscreen;
         crlf;
         crlf;
         d(config.textcolor,'You follow the map you have.');
         sd(config.textcolor,'After many hours of wandering you finally see light in the tunnel...');
         delay2(500);
         clearscreen;
         show_usurper_data(picture_ICE_CAVES,true);

         d(config.textcolor,'You have reached a place beyond the dungeons.');

         ice_caves(pl[1]^,pl[2]^,pl[3]^,pl[4]^);
         crlf;
         d(config.textcolor,'Back from the '+uwhite+'Ice-Caves'+config.textcol1+'..');
         crlf;

        end;}

       end; {*ICE-CAVES END*}

   'C':begin {change dungeon level}
        i:=global_dungeonlevel;

        crlf;
        d(config.textcolor,'There are a total of 100 dungeon levels. You can for the moment');
        sd(config.textcolor,'access levels ');
        sd(5,commastr(player.level));
        sd(config.textcolor,' - ');
        sd(5,commastr(player.level+10));
        sd(config.textcolor,'. Pick a new level :');

        zz:=get_number(0,200);

        if (zz>=player.level) and (zz<=player.level+10) then begin

         global_dungeonlevel:=zz;

         if global_dungeonlevel>101 then global_dungeonlevel:=101;

         if (global_dungeonlevel>90) and (global_registered=false) then begin
          crlf;
          d(12,'Sorry, you cannot reach further in the unregistered version');
          d(12,'of Usurper. Encourage your Sysop to register!');
          crlf;
          pause;
          global_dungeonlevel:=89;
         end
         else begin
          if global_dungeonlevel=i then begin
           crlf;
           sd(3,'You remain on level ');
           d(5,commastr(global_dungeonlevel));
          end
          else if global_dungeonlevel>i then begin
           crlf;
           sd(3,'You descend to level ');
           d(5,commastr(global_dungeonlevel));
          end
          else begin
           crlf;
           sd(3,'You ascend to level ');
           d(5,commastr(global_dungeonlevel));
          end;

         end;

         if (global_dungeonlevel=101) and (global_registered=true) then begin
          supreme(pl[1]^,pl[2]^,pl[3]^,pl[4]^);
         end;

        end
        else begin
         crlf;
         sd(config.textcolor,'You are on level ');
         d(5,commastr(global_dungeonlevel));
        end;
       end;
   'T':begin {team commands}

        if (player_active(pl[1]^,true)=false) and
           (player_active(pl[2]^,true)=false) and
           (player_active(pl[3]^,true)=false) and
           (player_active(pl[4]^,true)=false) then begin
         crlf;
         crlf;
         d(12,'Ha! You are alone.');
         crlf;
        end
        else begin
         done:=false;
         repeat
          crlf;
          crlf;
          s:='Your Party';
          d(14,s);
          d(10,cool_string(length(s),'=','-',2,10));

          {hitler}

          for i:=1 to global_maxteammembers-1 do begin

           if player_active(pl[i]^,true)=true then begin
            menu('['+commastr(i)+'] '+uplc+pl[i]^.name2+config.textcol1)
           end
           else begin
            menu('['+commastr(i)+'] '+ulgray+'---'+config.textcol1);
           end;

          end; {for i:= .end.}
          menu('(R)eturn');

          crlf;
          sd(config.textcolor,'Team Command :');

          {get user-input}
          cho:=upcase(getchar);

          {evaluate user-input}
          case cho of
           '1': if player_active(pl[1]^,true) then team_member_instruct(pl[1]^);
           '2': if player_active(pl[2]^,true) then team_member_instruct(pl[2]^);
           '3': if player_active(pl[3]^,true) then team_member_instruct(pl[3]^);
           '4': if player_active(pl[4]^,true) then team_member_instruct(pl[4]^);
           'R': done:=true;
          end; {case .end.}

          if (player_active(pl[1]^,true)=false) and
             (player_active(pl[2]^,true)=false) and
             (player_active(pl[3]^,true)=false) and
             (player_active(pl[4]^,true)=false) then begin
           crlf;
           d(12,'You are alone!');
           crlf;
           done:=true;
          end;

         until done;

        end;

       end;
   'L':begin {look for monsters}

        if (player.fights<=0) and (global_auto_probe=Nowhere) then begin
         crlf;
         d(12,'Sorry, you have no fights left for today.');
        end
        else begin

         crlf;
         crlf;
         d(config.textcolor,'looking...');
         if dungeon_event(pl[1]^,pl[2]^,pl[3]^,pl[4]^)=true then begin

          if global_killed then begin
           {save temm mates status}
           for i:=1 to 4 do begin
            custtemp^:=pl[i]^;
            if (custtemp^.name2<>'') and (custtemp^.name1<>'') then begin
             user_save(custtemp^);
            end;
           end;

           if global_killed=true then begin

            player.hps:=0;
            {player.allowed:=false;}
            Reduce_Player_Resurrections(player,true);

            post(MailSend,
            player.name2,
            player.ai,
            false,
            mailrequest_nothing,
            '',
            ulred+'Your Death'+config.textcol1,
            mkstring(10,underscore),
            'You were killed by a '+umonc+killed_by[1]+config.textcol1+' in the Dungeons.',
            '',
            '',
            '',
            '',
            '',
            '',
            '',
            '',
            '',
            '',
            '',
            '');

           end;
           normal_exit; {EVENTEN ended with player being killed}

          end;
         end
         else begin {player did not experience an EVENT, alas we bring
          in monsters instead! mohaha!}

          if (global_dungeonlevel>89) and (global_registered=false) then begin
           d(12,'Sorry, you cannot reach further in the unregistered version');
           d(12,'of Usurper. Encourage your Sysop to register!');
           crlf;
           pause;

           disposal;
           exit;
          end;

          Reset_Monsters;

          for i:=1 to global_maxspells do begin
           player.spell[i,2]:=false;
           for j:=1 to 4 do begin
            pl[j]^.spell[i,2]:=false;
           end;
          end; {for i:= .end.}

          {decrease dungeon fights}
          dec(player.fights);

          xx:=(global_dungeonlevel-1)*10;
          x:=global_dungeonlevel*10;
          repeat
           y:=random(x);
          until y>xx;

          load_monster(y,1);

          if player.level>99 then global_dungeonlevel:=101;

          if (global_dungeonlevel=101) and (global_registered=true) then begin
           y:=fs(FsMonster);
           load_monster(y-1,1);
           monster[1]^.hps:=player.hps*4;
           pause;
           supreme(pl[1]^,pl[2]^,pl[3]^,pl[4]^);
           normal_exit;
          end;

          if (global_dungeonlevel=101) and (global_registered=false) then begin
           crlf;
           d(12,'Sorry, you cannot reach further in the unregistered version');
           d(12,'of Usurper. Encourage your Sysop to register!');
           crlf;
           pause;
           normal_exit;
          end;

          {*Demon maybe!?*}
          if player.haunt>0 then begin
           newsy(true,
           'Demon Attack!',
           ' '+uplc+player.name2+config.textcol1+' was attacked by a '+umonc+'Demon'+config.textcol1+'!',
           '',
           '',
           '',
           '',
           '',
           '',
           '',
           '');

           {remove one demon from the players HAUNT LIST}
           dec(player.haunt);

           y:=random(1)+1;

           demon:=true;

           case random(6) of
            0: s:='Demon';
            1: s:='Rage Demon';
            2: s:='Dark Demon';
            3: s:='Hell Demon';
            4: s:='White Demon';
            5: s:='Red Demon';
           end;

           case random(10) of
            0: s2:='I have been waiting for you!';
            1: s2:='Annihilation is my profession...';
            2: s2:='I have been summoned to DESTROY you!';
            3: s2:='Risen from hell I have!';
            4: s2:='It is here were your adventure end!';
            5: s2:='Prepare to fight your last fight EVER!';
            6: s2:='I have come to bring you down!';
            7: s2:='I have been summoned to take care of YOU!';
            8: s2:='Kiss your life GOODBYE!';
            9: s2:='I have been choosen to kill you!';
           end;

           { debug info
           d(15,'demon hitpoints is '+commastr(player.maxhps*y));
           pause;
           }

           create_monster(1,                 {#}
                          s,                 {name}
                          player.maxhps*y,   {hps}
                          90,                {strength}
                          15,                {defence}
                          s2,                {phrase}
                          false,             {grabweap}
                          false,             {grabarm}
                          '*Super Strength', {weapon-string}
                          '',                {armor-string}
                          false,             {poisoned-should be false}
                          false,             {disease -should be false}
                          100+random(player.maxhps), {punch}
                          100,               {armpow}
                          0);                {weappow}
           crlf;
           d(config.textcolor,'The ground starts to tremble!');
           d(config.textcolor,'Through the shattered rocks something horrible');
           d(config.textcolor,'rise! A Demon has been summoned upon YOU!');
           crlf;
           d(config.textcolor,'Your grip to your weapon hardens...the Demon turns');
           d(config.textcolor,'it''s ugly head against you...');
           crlf;
           d(global_talkcol,s2);
           crlf;
           pause;
          end
          else begin
           {no demons are active opponents!}
           {it might be time to make MORE opponents instead!}
           {if the player has taken teammates with him then we must make
            a lot of monster!! :) }

           yy:=random(dungeon_difficulty)+1;
           if dungeon_difficulty=1 then yy:=1;

           if (pl[1]^.name2<>'') and (pl[1]^.hps>0) then yy:=yy*2;
           if (pl[2]^.name2<>'') and (pl[2]^.hps>0) then yy:=yy*2;
           if (pl[3]^.name2<>'') and (pl[3]^.hps>0) then yy:=yy*2;
           if (pl[4]^.name2<>'') and (pl[4]^.hps>0) then yy:=yy*2;

           if yy>global_maxmon then yy:=global_maxmon;

           for i:=2 to yy do begin
            xx:=(global_dungeonlevel-4)*10;
            if xx<1 then xx:=1;
            x:=global_dungeonlevel*10;
            repeat
             y:=random(x);
            until y>xx;

            {load a monster}
            load_monster(y,i);

           end;
          end;

          {setting some global variables}
          global_escape:=true;
          global_killed:=false;
          global_nobeg:=false;

          if demon=false then begin
           player_vs_monsters(pl_vs_monster,pl[1]^,pl[2]^,pl[3]^,pl[4]^);
          end
          else begin
           player_vs_monsters(pl_vs_demon,pl[1]^,pl[2]^,pl[3]^,pl[4]^);
          end;

          {Let Team-mates buy healing potions}
          for i:=1 to 4 do begin
           custtemp^:=pl[i]^;

           crlf;
           if (custtemp^.name2<>'') and (custtemp^.hps>0) then begin
            if custtemp^.healing<config.maxheals then begin

             z:=custtemp^.level*5;
             need:=config.maxheals-custtemp^.healing;

             incbankmoney(custtemp^,custtemp^.gold);

             custtemp^.gold:=0;

             if (need>0) and (custtemp^.bankgold>100) then begin
              z:=custtemp^.level*5;
              xx:=custtemp^.bankgold div z;
              if (xx)>need then begin
               xx:=need;
              end
              else begin
               need:=xx;
              end;

              if xx>0 then begin
               xx:=need*z;

               decbankmoney(custtemp^,xx);
               inc(custtemp^.healing,need);

               sd(global_plycol,custtemp^.name2);
               sd(config.textcolor,' bought ');
               sd(15,commastr(need));
               d(config.textcolor,' potions.');
               pause;
              end;

             end;

             pl[i]^:=custtemp^;
            end;
           end;
          end; {for i:= .end.}

          {does player need to buy healing potions?}
          need:=0;

          {if player is dead then there will be no purchase...}
          if player.hps<1 then begin
           need:=0;
          end
          else begin
           {does the player NEED to buy potions?}
           if player.healing<config.maxheals then begin
            need:=1;
           end;
          end;

          if need>0 then begin

           crlf;
           d(5,'* Meeting *');
           d(config.textcolor,'You are approached by a '+uplc+'monk'+config.textcol1+'.');
           d(config.textcolor,'He offers you to buy healing potions.');
           crlf;

           if confirm('Buy potions ','Y')=true then begin
            z:=player.level*5;

            sd(config.textcolor,'The price is ');
            sd(14,commastr(z));
            sd(config.textcolor,' '+config.moneytype+'/potion.');

            sd(config.textcolor,' ( you have ');
            sd(14,commastr(player.gold));
            sd(config.textcolor,' '+many_money(player.gold)+' )');
            crlf;

            xx:=player.gold div z;
            if player.healing+xx>config.maxheals then begin
             xx:=config.maxheals-player.healing;
            end;

            if xx<0 then xx:=0;

            sd(config.textcolor,'You can buy a maximum of ');
            sd(5,commastr(xx));
            sd(config.textcolor,' potions');
            sd(config.textcolor,' ( you have ');
            sd(5,commastr(player.healing));
            sd(config.textcolor,' potions )');

            crlf;
            d(config.textcolor,'How many would you like to buy');
            sd(config.textcolor,'(0-'+commastr(xx)+') ['+umag+commastr(xx)+config.textcol1+']:');
            zz:=get_number2(0,xx,xx);

            xx:=player.gold;
            xx:=zz*z;
            if xx>player.gold then begin
             crlf;
             d(global_talkcol,'Who are you trying to fool?');
             pause;
            end;
            if (player.gold>=xx) and (zz>0) and
               (zz+player.healing<=config.maxheals) then begin

             inc(player.healing,zz);
             decplayermoney(player,xx);

             d(global_talkcol,'Ok, it''s a deal.');
             d(config.textcolor,'You buy '+ulcyan+commastr(zz)+config.textcol1+' potions.');

             sd(global_plycol,'The '+uplc+'Monk'+config.textcol1+' ');
             case random(10) of
              0: d(config.textcolor,'smiles at you.');
              1: d(config.textcolor,'stares at you.');
              2: d(config.textcolor,'waves goodbye.');
              3: d(config.textcolor,'smirks.');
              5: d(config.textcolor,'walks away.');
              6: d(config.textcolor,'burps.');
              7: d(config.textcolor,'is silent.');
              8: d(config.textcolor,'smiles');
              9: d(config.textcolor,'wishes you good luck.');
             end; {case .end.}
             crlf;
            end
            else begin
             d(global_talkcol,'No deal.');
            end;
           end;
          end;

          {saving teamates status}
          for i:=1 to 4 do begin
           custtemp^:=pl[i]^;
           if (custtemp^.name2<>'') and (custtemp^.name1<>'') then begin
            user_save(custtemp^);
           end;
          end; {for i:= .end.}

          if global_killed=true then begin
           {player has been killed in the dungeons}

           player.gold:=0;
           player.hps:=0;

           {player.allowed:=false;}
           Reduce_Player_Resurrections(player,true);

           {inform player}
           post(MailSend,
           player.name2,
           player.ai,
           false,
           mailrequest_nothing,
           '',
           ulred+'Your Death'+config.textcol1,
           mkstring(10,underscore),
           'You were slaughtered by a '+umonc+killed_by[1]+config.textcol1+'.',
           '',
           '',
           '',
           '',
           '',
           '',
           '',
           '',
           '',
           '',
           '',
           '');

           if global_begged=true then begin
            s:=' '+uplc+player.name2+config.textcol1;
            case random(7) of
             0: s:=s+' begged for '+sex3[player.sex]+' miserable life, but ';
             1: s:=s+' tried to convince a grim monster not to kill '+sex[player.sex]+', but ';
             2: s:=s+' cried and begged for '+sex3[player.sex]+' life, but ';
             3: s:=s+' wept and begged for mercy, but ';
             4: s:=s+' gave up before '+sex3[player.sex]+' superior foe, but ';
             5: s:=s+' met superior forces, begged for '+sex3[player.sex]+' life, but ';
             6: s:=s+' chickened out in a fight! Begged, but ';
            end;

            case random(10) of
             0: s2:=' was brutally mutilated by a monster!';
             1: s2:=' was slain by a monster foe!';
             2: s2:=' was slaughtered by a monster!';
             3: s2:=' was killed without any mercy!';
             4: s2:=' received what '+sex2[player.sex]+' deserved. Death...';
             5: s2:=' was eliminated by a nice monster!';
             6: s2:=' was killed...';
             7: s2:=' the monster didn''t show any mercy...';
             8: s2:=' was killed instantly!';
             9: s2:=' was mutilated and tortured!';
            end; {case .end.}

            {news-paper}
            newsy(true,
            'Chicken in the Dungeons!',
            s,
            s2,
            '',
            '',
            '',
            '',
            '',
            '',
            '');

           end
           else begin

            s:=uplc+player.name2+config.textcol1;

            case random(4) of
             0: s:=s+' was killed by a '+umonc+killed_by[1]+config.textcol1+' in the dungeons.';
             1: s:=s+' was slain by a '+umonc+killed_by[1]+config.textcol1+' in the dungeons.';
             2: s:=s+' was slaughtered by a '+umonc+killed_by[1]+config.textcol1+' in the dungeons.';
             3: s:=s+' was defeated by a '+umonc+killed_by[1]+config.textcol1+' in the dungeons.';
            end;

            case random(6) of
             0: header:='Dungeon';
             1: header:='Tragic';
             2: header:='Deceased';
             3: header:='Slain';
             4: header:='Defeat';
             5: header:='Goner';
            end; {case .end.}

            header:=config.textcol1+header;

            {news-paper}
            newsy(false,
            header,
            ' '+s,
            '',
            '',
            '',
            '',
            '',
            '',
            '',
            '');

            {var teamet med?}
            for i:=1 to 4 do begin
             custtemp^:=pl[i]^;

             if custtemp^.name2<>'' then begin
              if custtemp^.hps>0 then begin
               newsy(false,
               ' '+uplc+custtemp^.name2+config.textcol1+' made it out alive...',
               '',
               '',
               '',
               '',
               '',
               '',
               '',
               '',
               '');
              end
              else begin
               newsy(false,
               ' '+uplc+custtemp^.name2+config.textcol1+' died along with '+sex3[custtemp^.sex]+' leader!',
               '',
               '',
               '',
               '',
               '',
               '',
               '',
               '',
               '');

               {skicka ett mess till den dde!}

               nice2[1]:='You died under the command of '+uplc+player.name2+config.textcol1+'!';
               nice2[2]:='You fought bravely, but the monsters were too strong...';
               nice2[3]:='A '+umonc+killed_by[i]+config.textcol1+' took your life.';
               team_report(custtemp^.name2,
                           3,
                           nice2[1],nice2[2],nice2[3],nice2[4]);

              end;
             end;
            end; {for i:= .end.}

            {news-paper}
            newsy(true,
            '',
            '',
            '',
            '',
            '',
            '',
            '',
            '',
            '',
            '');

            d(config.textcolor,'You fall to the ground...deadly injured...!');
            d(config.textcolor,'Your adventure ended in pain and misery!');
            d(config.textcolor,'You close your eyes...');
            d(config.textcolor,'Darkness...');
            crlf;
            pause;
           end;

           crlf;
           pause;
           normal_exit;
          end
          else begin

          end;
         end;
        end;
       end;
  end; {case .end.}

 until leave_dungeons;

 crlf;
 crlf;
 d(config.textcolor,'You begin your journey home...');
 {player has made it out alive}
 {was the team with him?}
 if (pl[1]^.name2<>'') or (pl[2]^.name2<>'') or (pl[3]^.name2<>'') or
    (pl[4]^.name2<>'') then begin

  {news-paper}
  newsy(false,
  'Party Returns',
  '',
  '',
  '',
  '',
  '',
  '',
  '',
  '',
  '');

  for i:=1 to 5 do begin
   case i of
    1: custtemp^:=player;
    2: custtemp^:=pl[1]^;
    3: custtemp^:=pl[2]^;
    4: custtemp^:=pl[3]^;
    5: custtemp^:=pl[4]^;
   end; {case .end.}

   if custtemp^.name2<>'' then begin
    if custtemp^.hps>0 then begin
     {news-paper}
     newsy(false,
     ' '+uplc+custtemp^.name2+config.textcol1+' the '+classnames[custtemp^.class]+' made it out alive from the Dungeons.',
     '',
     '',
     '',
     '',
     '',
     '',
     '',
     '',
     '');
    end
    else begin

     {create random "news of death"}
     case random(6) of
      0: s:=' '+uplc+custtemp^.name2+config.textcol1+' the '+classnames[custtemp^.class]+' was massacred by a '+umonc
               +killed_by[i]+config.textcol1+'!';
      1: s:=' '+uplc+custtemp^.name2+config.textcol1+' the '+classnames[custtemp^.class]+' encountered a '+umonc+killed_by[i]
               +config.textcol1+' and was killed.';
      2: s:=' '+uplc+custtemp^.name2+config.textcol1+' the '+classnames[custtemp^.class]+'s mutilated corpse was left behind.'
               +config.textcol1;
      3: s:=' '+uplc+custtemp^.name2+config.textcol1+' the '+classnames[custtemp^.class]+' was killed by a '+umonc+killed_by[i]
               +config.textcol1+'.';
      4: s:=' '+uplc+custtemp^.name2+config.textcol1+' the '+classnames[custtemp^.class]+'s life was taken by a '+umonc
               +killed_by[i]+config.textcol1+'.';
      5: s:=' '+uplc+custtemp^.name2+config.textcol1+' the '+classnames[custtemp^.class]+' was mauled by a '+umonc+killed_by[i]
               +config.textcol1+'.';
     end; {case .end.}

     {News-paper}
     newsy(false,
     s,
     '',
     '',
     '',
     '',
     '',
     '',
     '',
     '',
     '');

     {send a mess to the dead player!}
     nice2[1]:='You died under the command of '+uplc+player.name2+config.textcol1+'!';
     nice2[2]:='You fought bravely in the dungeons, but the monsters got you!';
     nice2[3]:='A '+umonc+killed_by[i]+config.textcol1+' took your life.';
     team_report(custtemp^.name2,
                 3,
                 nice2[1],
                 nice2[2],
                 nice2[3],
                 nice2[4]);
    end;

    {saving player}
    user_save(custtemp^);

   end;

  end; {for i:= .end.}

  {news-paper: send a ending crlf to the news file}
  newsy(true,
  '',
  '',
  '',
  '',
  '',
  '',
  '',
  '',
  '',
  '');
 end;

 {dispose of pointer variables}
 disposal;

end; {Dungeons *end*}

end. {Unit DungeonC .end.}
